package transform.test;

import org.jboss.soa.esb.actions.AbstractActionLifecycle;
import org.jboss.soa.esb.helpers.ConfigTree;
import org.jboss.soa.esb.message.Message;
import org.milyn.Smooks;
import org.milyn.SmooksException;
import org.milyn.event.report.HtmlReportGenerator;
import org.milyn.io.StreamUtils;
import org.milyn.container.ExecutionContext;
import org.xml.sax.SAXException;

import javax.servlet.ServletContext;
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.stream.StreamResult;
import java.io.*;
import java.util.ArrayList;


public class FileConvertorcsv2xmlAction extends AbstractActionLifecycle  {

   // private static byte[] messageIn = readInputMessage();
	 protected ConfigTree  _config;  
     
	  public FileConvertorcsv2xmlAction(ConfigTree config) {   
	   _config = config;   
	  }  
	
	

    protected static String runSmooksTransform(byte[] messageIn) throws IOException, SAXException, SmooksException {

        Smooks smooks = new Smooks("/META-INF/smooks-config.xml");

        try {
            ExecutionContext executionContext = smooks.createExecutionContext();
            StringWriter writer = new StringWriter();

            // Configure the execution context to generate a report...
            executionContext.setEventListener(new HtmlReportGenerator("target/report/report.html"));

            smooks.filterSource(executionContext, new StreamSource(new InputStreamReader(new ByteArrayInputStream(messageIn), "UTF-8")), new StreamResult(writer));

            return writer.toString();
        } finally {
            smooks.close();
        }
    }


    
    public Message process(Message message) throws Exception
	  {  
		  System.out.println("hello");  
	   String xmlString =(String) message.getBody().get();   
	    byte[] readMessage=readMessage(xmlString);
	   
	   System.out.println("\n\n==============Message In==============");
     //  System.out.println(new String(messageIn));
       System.out.println("======================================\n");

       String messageOut = FileConvertorcsv2xmlAction.runSmooksTransform(readMessage);
       FileWriter fileWriter = new FileWriter("outputdata.xml");  
       BufferedWriter bufferedWriter = new BufferedWriter(fileWriter);  
         
          
       bufferedWriter.write(messageOut);  
       bufferedWriter.flush();  
       bufferedWriter.close();  
       //fileWriter.flush();  
       fileWriter.close();  
       System.out.println("==============Message Out=============");
       System.out.println(messageOut);
       System.out.println("======================================\n\n");
	   
	   return message;   
	                  
	  }  

  /*  private static byte[] readInputMessage() {
        try {
            return StreamUtils.readStream(new FileInputStream("d:/xml/input-message.csv"));
        } catch (IOException e) {
            e.printStackTrace();
            return "<no-message/>".getBytes();
        }
    }*/
    private static byte[] readMessage(String msg) {
        return msg.getBytes();
    }
}
